]> git.decadent.org.uk Git - nfs-utils.git/blobdiff - debian/nfs-common.init
Only use rpcbind's rpcinfo when it's available
[nfs-utils.git] / debian / nfs-common.init
index f397e645045719f013acff294905d9ecc885540f..5e30d95998598f800ed10cb16ba46d43c95e84c5 100644 (file)
@@ -1,9 +1,10 @@
-#!/bin/sh
+#!/bin/bash
 
 ### BEGIN INIT INFO
 # Provides:          nfs-common
-# Required-Start:    $time
-# Default-Start:     2 3 4 5
+# Required-Start:    $portmap $time
+# Required-Stop:     $time
+# Default-Start:     2 3 4 5 S
 # Default-Stop:      0 1 6
 # Short-Description: NFS support files common to client and server
 # Description:       NFS is a popular protocol for file sharing across
@@ -17,11 +18,9 @@ DESC="NFS common utilities"
 # Read config
 DEFAULTFILE=/etc/default/nfs-common
 PREFIX=
-NEED_LOCKD=
+NEED_STATD=
 NEED_IDMAPD=
-IDMAPD_PIDFILE=/var/run/rpc.idmapd.pid
 NEED_GSSD=
-GSSD_PIDFILE=/var/run/rpc.gssd.pid
 PIPEFS_MOUNTPOINT=/var/lib/nfs/rpc_pipefs
 RPCGSSDOPTS=
 if [ -f $DEFAULTFILE ]; then
@@ -30,27 +29,8 @@ fi
 
 . /lib/lsb/init-functions
 
-# Determine whether lockd daemon is required.
-case "$NEED_LOCKD" in
-yes|no)        ;;
-*)  case `uname -r` in
-    '' | [01].* | 2.[0123].* )
-       # Older kernels may or may not need a lockd daemon.
-       # We must assume they do, unless we can prove otherwise.
-       # (A false positive here results only in a harmless message.)
-       NEED_LOCKD=yes
-       if test -f /proc/ksyms
-       then
-           grep -q lockdctl /proc/ksyms || NEED_LOCKD=no
-       fi
-       ;;
-
-    *)  # Modern kernels (>= 2.4) start a lockd thread automatically.
-       NEED_LOCKD=no
-       ;;
-    esac
-    ;;
-esac
+# Exit if required binaries are missing.
+[ -x $PREFIX/sbin/rpc.statd ] || exit 0
 
 #
 # Parse the fstab file, and determine whether we need idmapd and gssd. (The
@@ -60,21 +40,30 @@ esac
 AUTO_NEED_IDMAPD=no
 AUTO_NEED_GSSD=no
 
-exec 9<&0 </etc/fstab
+if [ -f /etc/fstab ]; then
+    exec 9<&0 </etc/fstab
 
-while read DEV MTPT FSTYPE OPTS REST
-do
-    if [ "$FSTYPE" = "nfs4" ]; then
-        AUTO_NEED_IDMAPD=yes
-    fi
-    case "$OPTS" in
-        sec=krb5|*,sec=krb5|sec=krb5,*|*,sec=krb5i,*|sec=krb5i|*,sec=krb5i|sec=krb5i,*|*,sec=krb5i,*|sec=krb5p|*,sec=krb5p|sec=krb5p,*|*,sec=krb5p,*)
-           AUTO_NEED_GSSD=yes
-       ;;
-    esac
-done
+    while read DEV MTPT FSTYPE OPTS REST
+    do
+       case $DEV in
+           ''|\#*)
+               continue
+               ;;
+       esac
+       # FSTYPE "nfs" can be NFSv4 now
+        #if [ "$FSTYPE" = "nfs4" ]; then
+            AUTO_NEED_IDMAPD=yes
+        #fi
+        case "$OPTS" in
 
-exec 0<&9 9<&-
+            sec=krb5|*,sec=krb5|sec=krb5,*|*,sec=krb5i,*|sec=krb5i|*,sec=krb5i|sec=krb5i,*|*,sec=krb5i,*|sec=krb5p|*,sec=krb5p|sec=krb5p,*|*,sec=krb5p,*)
+           AUTO_NEED_GSSD=yes
+            ;;
+        esac
+    done
+
+    exec 0<&9 9<&-
+fi
 
 #
 # We also need idmapd if we run an NFSv4 server. It's fairly difficult
@@ -85,10 +74,17 @@ exec 0<&9 9<&-
 # condition in nfs-kernel-server's init script does, which has a value in
 # itself.
 #
-if [ -f /etc/exports ]; then
+if [ -f /etc/exports ] && grep -q '^[[:space:]]*[^#]*/' /etc/exports; then
     AUTO_NEED_IDMAPD=yes
 fi
 
+case "$NEED_STATD" in
+    yes|no)
+        ;;
+    *)
+        NEED_STATD=yes
+        ;;
+esac
 
 case "$NEED_IDMAPD" in
     yes|no)    
@@ -106,14 +102,11 @@ case "$NEED_GSSD" in
        ;;
 esac
 
-# Exit if required binaries are missing.
-[ -x $PREFIX/sbin/rpc.statd ] || exit 0
-[ -x $PREFIX/sbin/rpc.lockd ] || [ "$NEED_LOCKD"  = no ] || exit 0
-[ -x /usr/sbin/rpc.idmapd   ] || [ "$NEED_IDMAPD" = no ] || exit 0
-[ -x /usr/sbin/rpc.gssd     ] || [ "$NEED_GSSD"   = no ] || exit 0
-
 do_modprobe() {
-    modprobe -q "$1" || true
+    if [ -x /sbin/modprobe -a -f /proc/modules ]
+    then
+        modprobe -q "$1" || true
+    fi
 }
 
 do_mount() {
@@ -142,51 +135,74 @@ case "$1" in
   start)
        log_daemon_msg "Starting $DESC"
 
-       log_progress_msg "statd"
-       start-stop-daemon --start --oknodo --quiet \
-           --exec $PREFIX/sbin/rpc.statd -- $STATDOPTS
-       if [ $? != 0 ]; then
-           log_end_msg $?
-           exit $?
-       fi
-
-       if [ "$NEED_LOCKD" = yes ]
-       then
-           log_progress_msg "lockd"
+       if [ "$NEED_STATD" = yes ]; then
+           log_progress_msg "statd"
+           
+           # See if rpcbind is running
+           if [ -x /usr/sbin/rpcinfo ]; then
+               /usr/sbin/rpcinfo -p >/dev/null 2>&1
+               RET=$?
+               if [ $RET != 0 ]; then
+                  echo
+                  log_warning_msg "Not starting: portmapper is not running"
+                  exit 0
+               fi
+           fi
            start-stop-daemon --start --oknodo --quiet \
-               --exec $PREFIX/sbin/rpc.lockd
-           if [ $? != 0 ]; then
-               log_end_msg $?
-               exit $?
-            fi
+               --pidfile /var/run/rpc.statd.pid \
+               --exec $PREFIX/sbin/rpc.statd -- $STATDOPTS
+           RET=$?
+           if [ $RET != 0 ]; then
+               log_end_msg $RET
+               exit $RET
+           else
+               mkdir -p /lib/init/rw/sendsigs.omit.d
+               rm -f /lib/init/rw/sendsigs.omit.d/statd
+               ln -s /var/run/rpc.statd.pid /lib/init/rw/sendsigs.omit.d/statd
+           fi
        fi
+
+       # Don't start idmapd and gssd if we don't have them (say, if /usr is not
+       # up yet).
+       [ -x /usr/sbin/rpc.idmapd ] || NEED_IDMAPD=no
+       [ -x /usr/sbin/rpc.gssd   ] || NEED_GSSD=no
+
        if [ "$NEED_IDMAPD" = yes ] || [ "$NEED_GSSD" = yes ]
        then
+           do_modprobe sunrpc
            do_modprobe nfs
-           do_modprobe nfs4
+           do_modprobe nfsd
            if do_mount rpc_pipefs $PIPEFS_MOUNTPOINT
            then
                if [ "$NEED_IDMAPD" = yes ]
                then
                    log_progress_msg "idmapd"
                    start-stop-daemon --start --oknodo --quiet \
-                           --make-pidfile --pidfile $IDMAPD_PIDFILE \
                            --exec /usr/sbin/rpc.idmapd
-                   if [ $? != 0 ]; then
-                       log_end_msg $?
-                       exit $?
+                   RET=$?
+                   if [ $RET != 0 ]; then
+                       log_end_msg $RET
+                       exit $RET
                     fi
                fi
                if [ "$NEED_GSSD" = yes ]
                then
                    do_modprobe rpcsec_gss_krb5
                    log_progress_msg "gssd"
+
+                   # we need this available; better to fail now than
+                   # mysteriously on the first mount
+                   if ! grep -q -E '^nfs[       ]' /etc/services; then
+                       log_action_end_msg 1 "broken /etc/services, please see /usr/share/doc/nfs-common/README.Debian.nfsv4"
+                       exit 1
+                   fi
+
                    start-stop-daemon --start --oknodo --quiet \
-                           --make-pidfile --pidfile $GSSD_PIDFILE \
                            --exec /usr/sbin/rpc.gssd -- $RPCGSSDOPTS
-                   if [ $? != 0 ]; then
-                       log_end_msg $?
-                       exit $?
+                   RET=$?
+                   if [ $RET != 0 ]; then
+                       log_end_msg $RET
+                       exit $RET
                     fi
                fi
            fi
@@ -202,81 +218,67 @@ case "$1" in
            log_progress_msg "gssd"
            start-stop-daemon --stop --oknodo --quiet \
                    --name rpc.gssd
-           if [ $? != 0 ]; then
-                log_end_msg $?
-                exit $?
+           RET=$?
+           if [ $RET != 0 ]; then
+                log_end_msg $RET
+                exit $RET
             fi
-           rm -f $GSSD_PIDFILE
        fi
        if [ "$NEED_IDMAPD" = yes ]
        then
            log_progress_msg "idmapd"
            start-stop-daemon --stop --oknodo --quiet \
                --name rpc.idmapd
-           if [ $? != 0 ]; then
-                log_end_msg $?
-                exit $?
+            RET=$?
+           if [ $RET != 0 ]; then
+                log_end_msg $RET
+                exit $RET
             fi
-           rm -f $IDMAPD_PIDFILE
        fi
-       if [ "$NEED_LOCKD" = yes ]
+       if [ "$NEED_STATD" = yes ]
        then
-           log_progress_msg "lockd"
+           log_progress_msg "statd"
            start-stop-daemon --stop --oknodo --quiet \
-               --name rpc.lockd
-           if [ $? != 0 ]; then
-                log_end_msg $?
-                exit $?
+               --name rpc.statd
+           RET=$?
+           if [ $RET != 0 ]; then
+                log_end_msg $RET
+                exit $RET
             fi
-       else
-           pkill -KILL -u root -x lockd || true
        fi
-       log_progress_msg "statd"
-       start-stop-daemon --stop --oknodo --quiet \
-           --name rpc.statd
-       if [ $? != 0 ]; then
-            log_end_msg $?
-            exit $?
-        fi
        do_umount $PIPEFS_MOUNTPOINT 2>/dev/null || true
        log_end_msg 0
        ;;
 
   status)
-       if ! pidof rpc.statd >/dev/null
-       then
-           echo "rpc.statd not running"
-           exit 3
-       fi
-
-       if [ "$NEED_GSSD" = yes ]
+       if [ "$NEED_STATD" = yes ]
        then
-            if [ ! -f "$GSSD_PIDFILE" ] || ! pidof rpc.gssd >/dev/null
+           if ! pidof rpc.statd >/dev/null
            then
-               echo "rpc.statd running, but rpc.gssd halted"
-               exit 3
+               echo "rpc.statd not running"
+               exit 3
            fi
        fi
 
-       if [ "$NEED_LOCKD" = yes ]
+       if [ "$NEED_GSSD" = yes ]
        then
-           if ! pidof rpc.lockd >/dev/null
+            if ! pidof rpc.gssd >/dev/null
            then
-               echo "rpc.statd running, but rpc.lockd halted"
+               echo "rpc.gssd not running"
                exit 3
            fi
        fi
-           
+
        if [ "$NEED_IDMAPD" = yes ]
        then
-            if [ ! -f "$IDMAPD_PIDFILE" ] || ! pidof rpc.idmapd >/dev/null
+            if ! pidof rpc.idmapd >/dev/null
            then
-               echo "rpc.statd running, but rpc.idmapd halted"
+               echo "rpc.idmapd not running"
                exit 3
            fi
        fi
 
-       echo "rpc.statd running"
+       echo "all daemons running"
        exit 0
        ;;